import string, os
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFPortlets import CMFPortlets_globals

def install(self):
    
    pt = getToolByName(self, 'portal_types')
    try:
        pt.manage_addTypeInformation('Factory-based Type Information',id='Portlet',
                                  typeinfo_name='CMFDefault: Skinned Folder')
        pt.manage_addTypeInformation('Factory-based Type Information',id='Portlet Document',
                                  typeinfo_name='CMFDefault: Document')
        pt.manage_addTypeInformation('Factory-based Type Information',id='Portlet Topic',
                                  typeinfo_name='CMFTopic: Portal Topic')
    except:
        pass

    pl=getattr(pt, 'Portlet')
    pl.manage_editProperties( { 'immediate_view': 'portlet_edit_form', 'content_meta_type': 'Skinned Folder', 
                      'global_allow': 'on', 'allowed_content_types': ['Portlet Document', 'Portlet Topic'],
                      'content_icon': 'folder_icon.gif', 'factory': 'addSkinnedFolder', 'product': 'CMFDefault', 
                       'title': '', 'description': 'Portlet creation', 'filter_content_types': 'on'} )
    pl.changeActions({'action': '', 'id_1': 'edit', 'action_0': 'portlet_view', 'id_3': 'portletPreferences',
              'id_2': 'foldercontents', 'visible_1': '1', 'visible_0': '1', 'visible_3': '1', 'visible_2': '1', 'name': '', 'category': '', 'id': '',
               'permission_3': 'Set own properties', 'permission_2': 'List folder contents', 'permission_1': 'Manage properties', 'permission_0': 'View',
                'changeActions': 'Save', 'visible': '1', 'category_0': 'folder', 'category_1': 'folder', 'category_2': 'folder', 'category_3': 'folder',
            'action_1': 'portlet_edit_form', 'action_2': 'folder_contents', 'permission': '', 'id_0': 'view', 'action_3': 'portlet_preferences',
                    'name_1': 'Edit', 'name_0': 'View', 'name_3': 'Portlet Preferences', 'name_2': 'Folder contents'})
    pd=getattr(pt, 'Portlet Document')
    pd.manage_editProperties({ 'factory': 'addDocument', 'immediate_view': 'document_edit_form', 'content_meta_type': 'Document', 
                       'filter_content_types': 'on', 'title': '', 
                         'description': "Documents can contain text that can be formatted using 'Structured Text.'", 
                          'global_allow': 'on', 'product': 'CMFDefault', 'content_icon': 'document_icon.gif'})
    pd.changeActions({'action': '', 'id_1': 'edit', 'action_1': 'document_edit_form', 'id_2': 'metadata', 'visible_1': '1', 'visible_0': '1',
            'visible_2': '1', 'name': '', 'category': '', 'id': '', 'action_0': 'document_view_fportlets', 'permission_2': 'Modify portal content',
    'permission_1': 'Modify portal content', 'permission_0': 'View', 'visible': '1', 'category_0': 'object', 'category_1': 'object', 'category_2': 'object',
    'changeActions': 'Save', 'action_2': 'metadata_edit_form', 'permission': '', 'id_0': 'view', 'name_1': 'Edit', 'name_0': 'View', 'name_2': 'Metadata'})
    pto=getattr(pt, 'Portlet Topic')
    pto.manage_editProperties({'factory': 'addTopic', 'immediate_view': 'topic_edit_form', 'content_meta_type': 'Portal Topic', 
                    'title': '', 'description': 'Topics are canned queries for organizing content with up to date queries into the catalog.',
                     'global_allow': 'on', 'product': 'CMFTopic', 'content_icon': 'topic_icon.gif'})
    pto.changeActions({'action': '', 'id_1': 'edit', 'action_0': 'topic_view_fportlets', 'id_3': 'subtopics', 'id_2': 'criteria', 'visible_1': '1',
            'visible_0': '1', 'visible_3': '1', 'visible_2': '1', 'name': '', 'category': '', 'id': '', 'permission_3': 'Change portal topics',
                   'permission_2': 'Change portal topics', 'permission_1': 'Change portal topics', 'permission_0': 'View', 'changeActions': 'Save',
        'visible': '1', 'category_0': 'object', 'category_1': 'object', 'category_2': 'object', 'category_3': 'object', 'action_1': 'topic_edit_form',
        'action_2': 'topic_criteria_form', 'permission': '', 'id_0': 'view', 'action_3': 'topic_subtopics_form', 'name_1': 'Edit', 'name_0': 'View',
                               'name_3': 'Subtopics', 'name_2': 'Criteria'})

    ps = getToolByName(self, 'portal_skins')
    try: addDirectoryViews(ps, 'skins', CMFPortlets_globals)
    except: return "<html>You must have already installed CMFPortlets</html>"

    
    path = ['custom', 'CMFPortlets', 'zpt_topic', 'zpt_content', 'zpt_generic', 'zpt_control', 'topic', 'content', 'generic', 'control', 'Images']
    path = string.join( path, ', ' )
    ps.addSkinSelection( 'CMFPortlets_preview', path )
    ps.manage_properties(default_skin='CMFPortlets_preview')
    
    sfolder = getattr(ps, 'custom')
    sfolder.manage_addDTMLDocument('NotFoundObject')
    doc = getattr(sfolder, 'NotFoundObject')

    doccontent = """<dtml-comment>
    Used by 'portlets_RenderingEngine' to render a replacement box when the selected by the user can't be found
    </dtml-comment>

    <p>&nbsp;</p>The selected portlet couln't been found. <br>
    You may remove this box.<p>&nbsp;</p>"""

    doc.manage_edit(doccontent, 'Portlet not found!...')



    #pmemship = context.portal_membership
    pmemship = getToolByName(self, 'portal_membership')
    pmemship.changeActions({'condition_6': 'python: member and hasattr(portal.portal_membership.getHomeFolder(), "Favorites")', 'action': '',
        'condition_2': 'member', 'condition_3': 'member', 'condition_0': 'python: member', 'condition_1': 'not: member', 'id_1': 'login', 'id_0': 'mypage',
        'condition_4': 'portal/portal_membership/getHomeFolder', 'condition_5': 'python: member and portal.portal_membership.getHomeFolder()',
        'category_1': 'user', 'action_6': 'string:${portal/portal_membership/getHomeUrl}/Favorites/folder_contents', 'name': '', 'condition': '',
        'permission_3': 'View', 'permission_2': 'View', 'permission_1': 'View', 'permission_0': 'View', 'permission_6': 'View', 'permission_5': 'View',
        'permission_4': 'View', 'permission': '', 'visible': '1', 'id': '', 'name_0': 'MyPage', 'visible_1': '1', 'visible_0': '1', 'visible_3': '1',
        'visible_2': '1', 'visible_5': '1', 'visible_4': '1', 'visible_6': '1', 'id_4': 'addFavorite', 'category': '', 'id_6': 'favorites',
        'changeActions': 'Save', 'action_0': 'string:${portal_url}/page_view', 'action_1': 'string:${portal_url}/login_form',
        'action_2': 'string:${portal_url}/personalize_form', 'action_3': 'string:${portal_url}/logout', 'action_4': 'string:${object_url}/addtoFavorites',
        'action_5': 'string:${portal/portal_membership/getHomeUrl}/folder_contents', 'id_2': 'preferences', 'category_0': 'user', 'id_5': 'mystuff',
        'category_2': 'user', 'category_3': 'user', 'category_4': 'user', 'category_5': 'user', 'category_6': 'user', 'name_5': 'My stuff',
        'name_4': 'Add to favorites', 'name_6': 'My favorites', 'name_1': 'Login', 'id_3': 'logout', 'name_3': 'Log out', 'name_2': 'Preferences'})


    #pmemdata = context.portal_memberdata
    pmemdata = getToolByName(self, 'portal_memberdata')
    pmemdata.manage_addProperty('personal_selections', [], 'lines' )



    return "<html><h3>It worked!. </h3>You may now delete the installer.</html>"
